
REGENERATEONLOAD = 1
import string
  
GRAMMARString ="""
  _pformula ::
    @R _unary_1 :: _unary >> NOT
    @R _unary_2 :: _unary >> AX
    @R _unary_3 :: _unary >> EX
    @R _binary_1 :: _binary >> AND
    @R _binary_2 :: _binary >> AU
    @R _binary_3 :: _binary >> EU
    @R _rest_1 :: _rest >> _binary _pformula
    @R _rest_2 :: _rest >> 
    @R _pformula_1 :: _pformula >> _PREDICATE _rest
    @R _pformula_2 :: _pformula >> _unary _pformula
"""
COMPILEDFILENAME   ='ctlGG.py'
MARSHALLEDFILENAME ='ctlGG.mar'
# PARSER/SEMANTICS BINDINGS 
_RGX_PREDICATE = '[a-z][A-Za-z0-9_]*'
def _S_PREDICATE(str):
  return str # automatic, default

def _DeclareTerminals(G):
  G.Addterm("_PREDICATE", _RGX_PREDICATE, _S_PREDICATE)
def _S_unary_1(list, Context):  #  >> "NOT"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  a.value.setValue((['NOT', 'AX', 'EX'], 0))
  a.graphObject_.ModifyAttribute("value", "NOT")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_unary_2(list, Context):  #  >> "AX"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100        
  a.value.setValue((['NOT', 'AX', 'EX'], 1))
  a.graphObject_.ModifyAttribute("value", "AX")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_unary_3(list, Context):  #  >> "EX"
  a = at3.createNewCTLUnary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  a.value.setValue((['NOT', 'AX', 'EX'], 2))
  a.graphObject_.ModifyAttribute("value", "EX")
  TRAP_res=a
  _TRAP_typecheck("CTLUnary", "",  TRAP_res, 'Semantics value for nonterminal "unary"')
  return TRAP_res

def _S_binary_1(list, Context):  #  >> "AND"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 0))
  a.graphObject_.ModifyAttribute("value", "AND")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_binary_2(list, Context):  #  >> "AU"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 1))
  a.graphObject_.ModifyAttribute("value", "AU")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_binary_3(list, Context):  #  >> "EU"
  a = at3.createNewCTLBinary(at3, at3.ctlpx, at3.ctlpy)
  at3.ctlpy+=100
  at3.ctlpx+=100
  a.value.setValue((['AND', 'AU', 'EU'], 2))
  a.graphObject_.ModifyAttribute("value", "EU")
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "binary"')
  return TRAP_res

def _S_rest_1(list, Context):  #  >> pformula=ROper
  ROper=list[1]
  Bin=list[0]
  a = at3.createNewCTLBinaryOperRight(at3, at3.ctlpx, at3.ctlpy)
  at3.drawConnections((Bin, a), (a, ROper))
  at3.level = at3.level - 1
  TRAP_res=Bin
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "rest"')
  return TRAP_res

def _S_rest_2(list, Context):  #  >> pformula=ROper
  a = None
  at3.ctlpy+=100
  TRAP_res=a
  _TRAP_typecheck("CTLBinary", "",  TRAP_res, 'Semantics value for nonterminal "rest"')
  return TRAP_res

def _S_pformula_1(list, Context):  #  >> rest=Bin
  Pred=list[0]
  Bin=list[1]
  at3.level = at3.level+1
  at3.ctlpx-=100
  pr = at3.createNewCTLPredicate(at3, at3.ctlpx, at3.ctlpy)
  print "creating predicate ", Pred, "at :", at3.ctlpx, at3.ctlpy, "level = ", at3.level
  pr.value.setValue(Pred)
  pr.graphObject_.ModifyAttribute("value", Pred)
  aux = pr
  if Bin:
     a = at3.createNewCTLBinaryOperLeft(at3, at3.ctlpx, at3.ctlpy)
     at3.drawConnections((Bin, a), (a, pr))
  TRAP_res=aux
  _TRAP_typecheck("ASGNode", "",  TRAP_res, 'Semantics value for nonterminal "pformula"')
  return TRAP_res

def _S_pformula_2(list, Context):  #  >> pformula=Sfor
  Sfor=list[1]
  UnOp=list[0]
  aux = UnOp
  a = at3.createNewCTLUnaryOper(at3, at3.ctlpx, at3.ctlpy)
  at3.drawConnections((UnOp, a), (a, Sfor))
  TRAP_res=aux
  _TRAP_typecheck("ASGNode", "",  TRAP_res, 'Semantics value for nonterminal "pformula"')
  return TRAP_res

def _BindRules(G):
  G.Bind( "_unary_1", _S_unary_1 )
  G.Bind( "_unary_2", _S_unary_2 )
  G.Bind( "_unary_3", _S_unary_3 )
  G.Bind( "_binary_1", _S_binary_1 )
  G.Bind( "_binary_2", _S_binary_2 )
  G.Bind( "_binary_3", _S_binary_3 )
  G.Bind( "_rest_1", _S_rest_1 )
  G.Bind( "_rest_2", _S_rest_2 )
  G.Bind( "_pformula_1", _S_pformula_1 )
  G.Bind( "_pformula_2", _S_pformula_2 )



# COMPILER FRAME PROPER  
def GrammarBuild():
    import kjParseBuild
    global GenG # for LLXDoParse
    GenG = kjParseBuild.NullCGrammar()


    GenG.SetCaseSensitivity(1) # grammar is case sensitive for keywords
    _DeclareTerminals(GenG)
  
    GenG.Keywords("AND NOT AU AX EU EX")
    GenG.punct("")
    GenG.Nonterms("_unary _binary _rest _pformula")
    GenG.comments([])

    GenG.Declarerules(GRAMMARString)
    GenG.Compile()
    # print "LEXER ON GENERATION:"; GenG.LexD.Dump() ###
    
  
    # print "dumping as python to "+COMPILEDFILENAME
    # outfile = open(COMPILEDFILENAME, "w")
    # GenG.Reconstruct("GenG",outfile,"GRAMMAR")
    # outfile.close()
  
    print "dumping as binary to "+MARSHALLEDFILENAME
    outfile = open(MARSHALLEDFILENAME, "wb")
    GenG.MarshalDump(outfile)
    outfile.close()
    print "PARSER CONFLICTS:  %3i S/R,  %3i R/R" % (kjParseBuild.N_conflictRR, kjParseBuild.N_conflictSR) ###
  
    _BindRules(GenG)
    return GenG
  
if REGENERATEONLOAD:
   print "(re)generating the grammar..."
   Dummy = GrammarBuild()
   print "(re)generation done."

