import tkFileDialog
import re

class GenModelFromXPNS:
	def __self__(self):
		#self.metamodel = metamodel
		pass
	
	def buildModel(self, model):
		filename = tkFileDialog.askopenfilename(filetypes=[("XPNS Files", "*.net")])

		if filename == "":
			return

		f = open(filename, "r")
		line = f.readline()

		places = []
		transitions = []

		while(line):
			if (line[0] == '*'): # Comment
				line = f.readline()
				continue

			entity = re.split(": ", line)
			type = entity[0] # This is the type of object with an id

			if (type[0] == 'S'): # Place
				params = re.split("~", entity[1])
				name = params[1]
				params = re.split(" ", params[2])
				x = int(params[2])
				y = int(params[3])
				newPlace = model.createNewPNPlace(model, x, y)
				newPlace.name.setValue(name)
				newPlace.tokens.setValue(int(params[1]))
				newPlace.graphObject_.ModifyAttribute("name", newPlace.name.toString())
				newPlace.graphObject_.ModifyAttribute("tokens", newPlace.tokens.toString())
				places.append((newPlace, x, y, int(type[1:])))
				
			elif (type[0] == 'T'): # Transition
				params = re.split("~", entity[1])
                                name = params[1]
                                params = re.split(" ", params[2])
				x = int(params[2])
				y = int(params[3])
				newTransition = model.createNewPNTransition(model, x, y)
				newTransition.name.setValue(name)
				newTransition.graphObject_.ModifyAttribute("name", newTransition.name.toString())
				transitions.append((newTransition, x, y, int(type[1:])))

			elif (type == "KST"): # Connection from Place to Transition
				params = re.split(" ", entity[1])
				placetuple = getHashedValue(int(params[0]), places)
				place = placetuple[0]
				px = placetuple[1]
				py = placetuple[2]

				trantuple = getHashedValue(int(params[1]), transitions)
                                tran = trantuple[0]
                                tx = trantuple[1]
                                ty = trantuple[2]

				weight = abs(int(params[3]))

				newpl2tran = model.createNewpl2tran(model, int((px+tx)/2), int((py+ty)/2))
				newpl2tran.weight.setValue(weight)
				newpl2tran.graphObject_.ModifyAttribute("weight", newpl2tran.weight.toString())

				model.drawConnections((place, newpl2tran))
				model.drawConnections((newpl2tran, tran))

			elif (type == "KTS"): # Connection from Transition to Place
				params = re.split(" ", entity[1])
				placetuple = getHashedValue(int(params[0]), places)
                                place = placetuple[0]
                                px = placetuple[1]
                                py = placetuple[2]

				trantuple = getHashedValue(int(params[1]), transitions)
                                tran = trantuple[0]
                                tx = trantuple[1]
                                ty = trantuple[2]

				weight = abs(int(params[3]))

                                newtran2pl = model.createNewtran2pl(model, int((px+tx)/2), int((py+ty)/2))
				newtran2pl.weight.setValue(weight)
				newtran2pl.graphObject_.ModifyAttribute("weight", newtran2pl.weight.toString())

                                model.drawConnections((tran, newtran2pl))
                                model.drawConnections((newtran2pl, place))

			else:
				print "Error: Corrupted PNS file"

			line = f.readline()

def getHashedValue(index, tuplelist):
	for tuple in tuplelist:
		if tuple[3] == index:
			return tuple
	return None
